/*
  Tutanchamun, an arcade game
  Copyright (C) 1998  David Kastrup
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
#include "tutan.h"

unsigned long produc[] = {
  0x77ff0040, 0x00000888, 0x5dee8880, 0x00008008,
  0xbdea88cc, 0x00000080, 0x8cee8808, 0x00000008
};

void prod(int *hl)
{
  protype * const prodta = playfield[player].stage.prodta;
  int i;
  int monstyp;
  int b;
  mcb *mp;

  *hl = playfield[player].stage.speed;

  for (i=0; i<7; ++i ) {
    if (prodta[i].pos.x == 0)
      return;
    if (prodta[i].pos.x - scrx >= 45) {
      prodta[i].downcn = 0xff;
      continue;
    }
    if (prodta[i].downcn > 127)
      prodta[i].downcn = 25;
    else if (prodta[i].downcn-- == 0) {
      prodta[i].monpat = (prodta[i].monpat << 8) | (prodta[i].monpat & 0xff);
      prodta[i].downcn = 15;
    }
    if (prodta[i].downcn >= 16)
      continue;
    monstyp = prodta[i].monpat >> 30;
    prodta[i].monpat = (prodta[i].monpat & 0xffffff)
                      | ((prodta[i].monpat & 0x3f000000) << 2)
                      | ((prodta[i].monpat & 0xc0000000) >> 6);
    b = prodta[i].propos++;
    if (!((produc[b>>5] >> (31-(b & 31))) & 1) || monstyp == 0 || nmons == 12)
      continue;
							    
    mp = freemcb;
    freemcb = freemcb->next;
    mp->next = mymcb.next;
    mymcb.next = mp;
    mp->flag = 1 << BIRTH;
    mp->downcn = 5;
    mp->xcoor = prodta[i].pos.x;
    mp->ycoor = prodta[i].pos.y;
    mp->shape = d_cloudshapes;
    mp->mph = playfield[player].stage.mons[monstyp-1];
    ++nmons;
  }
}
  
